libname rsch "c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\rsch\";
libname crsp "c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\crsp\";
libname temp "c:\sas data\temp" OUTREP=WINDOWS_32;
libname ind "c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\sas data\";
Options Mautosource Sasautos="c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\sas programs\sas macros\";
ods graphics off;

**********************************************************************************
					Create RAWS
**********************************************************************************;


%create_pay;


proc sql; create table temp0 as select distinct
a.vid, a.date as rdate format yymmddn8., a.ex, a.exchcd, a.me, a.me as mep, b.be as be, b.bm_ff as bm, b.bm as bm_af from rsch.msf a left join rsch.bm b on a.vid=b.vid and a.date=b.rdate;

create table temp1 as select distinct
a.*, b.* from temp0 a left join rsch.acc b on a.vid=b.vid and a.rdate=b.rdate;

create table temp2 as select distinct
a.*, b.beta
from temp1 a left join rsch.betas_fp b on a.vid=b.vid and a.rdate=b.rdate; 

create table temp3 as select distinct
a.*, b.pay from temp2 a left join ind.pay b on  a.vid=b.vid and intck('month', a.rdate, b.rdate)=0 ;


data ind.raws(drop = beta2) ; set temp3; 
if beta = . then beta = beta2;
run;


proc delete data = _all_; run;



**********************************************************************************
							PREPARE EXPECTATIONS
**********************************************************************************;

proc sql ;  create table tp as select distinct a.* from ind.expectations a where vid in (select distinct vid from rsch.msf)
order by vid , statpers ; create table dates as select distinct statpers from tp ; 
create table dates as select distinct statpers , min(date) as date format yymmddn8. from dates a, crsp.dsi b where date>= statpers group by statpers ; 
create table tp as select distinct vid , date , a.* from tp a , dates b where a.statpers = b.statpers order by vid , date; 

data tp; set tp; month=month(date); year=year(date);run;
proc sql;create table output as select distinct
ex, vid, date, statpers, measure, FISCALP, numest, medest, meanest, max(date) as last_date
from tp group by vid, month, year; data output(drop = last_date); set output; where date= last_date;run;

proc sql; create table msf as select distinct
a.ex, a.vid, a.date, a.ret,  a.me, a.indus, a.exchcd, statpers as date_of_exp, measure, FISCALP, numest, medest, meanest
from rsch.msf a, output b where a.vid=b.vid and month(a.date)=month(b.date) and year(a.date)=year(b.date) order by vid, date;

data msf; set msf; by vid date; delta_exp = medest-lag(medest); delta_months = intck('month', lag(date), date);
if first.vid then delta_exp = . ; if first.vid then delta_months = . ; format delta_exp 11.6; run;

proc sql; create table ind.msf_exp as select distinct a.*, b.*, a.me as mew 
from ind.raws a , msf b where a.vid=b.vid and a.rdate=b.date order by ex, rdate;

proc rank data = ind.msf_exp out = ind.msf_exp_percent PERCENT; by ex rdate ; var medest beta op inv bm pay mew; run;

proc sql; create table nr_firms as select distinct vid, min(date) format yymmddn8. from ind.msf_exp_percent where medest ne .;

proc sql; create table nr_firms2 as select distinct vid from ind.msf_dur ;

proc delete data = _all_; run;


**********************************************************************************
					Estimate Duration Characteristic
**********************************************************************************;


proc reg data = ind.msf_exp_percent rsquare;where ex="USA" ; model meanest =  op inv beta pay ; weight numest; run; quit;


proc reg data = ind.msf_exp_percent noprint outest = b1 rsquare; by ex; model medest = op bm inv beta pay ; weight numest; run; quit;

proc sql; create table temp3 as select distinct
a.*, b.op as bop, b.inv as binv, b.beta as bbeta, b.bm as bbm, b.pay as bpay
from ind.raws a , b1 b where a.ex=b.ex
order by ex, rdate;

data temp3; set temp3; proc sort; by ex rdate; run;

proc rank data = temp3 out = temp4 percent; by ex rdate; var op inv bm mep beta pay ; run; 

data temp4; set temp4;rmw = op ; cma = - inv; 
inv2 = inv;    if inv = .  then inv2   = 50;
op2 = op;      if op = .   then op2    = 50;
bm2 = bm;      if bm = .   then bm2    = 50;
beta2 = beta;  if beta = . then beta2  = 50;
pay2 = pay;    if pay = .  then pay2   = 50;

o   = op2*bop;
in  = inv2*binv;
b   = bm2*bbm;
bet = beta2 * bbeta;
p   = pay2 * bpay;
dur = sum(o, in, p, bet); 


***** Alternative specification based on univariate correlations ****** ;

*o   = op2	 * 0.09;
*in  = inv2	 * 0.35;
*bet = beta2  * 0.37;
*p   = pay2   * 0.35;
*dur = sum(o, in, p, bet); 

*** Alternative based on simple averages ***** ;

*op_t = -1*op2; *pay_t = -1*pay2; *bm_t = -1*bm2;
*dur = sum(op_t, pay_t, beta2, inv2, bm_t);

keep_obs = 1;
if beta = . and inv = . and op = . and pay = . then keep_obs = 0; 

run;

data ind.msf_dur; set temp4;format dur 9.4; keep ex me me_company exchcd cma rmw op inv bm rdate vid dur beta  bop binv bbm  bbeta beta2  bm2 op2 inv2 bop binv bbm  bbeta ltg_hat m bme mep mep2 medest p pay bpay keep_obs; run;
data ind.asf_dur; set temp4;format dur 9.4; keep ex me me_company exchcd cma rmw op inv bm rdate vid dur beta  bop binv bbm  bbeta keep_obs; where month(rdate) = 6; run;

proc delete data = _all_ ; run; 

*** ADD TO EXP FILE;

data temp; set ind.msf_dur; proc sort; by ex rdate; run;
proc rank data = temp out = temp2 PERCENT; by ex rdate ; var dur; run;
proc sql; create table msf_exp_percent as select distinct a.*, b.dur from ind.msf_exp_percent a left join temp2 b on a.vid=b.vid and a.rdate=b.rdate order by ex, date;


data ind.msf_exp_percent; set msf_exp_percent;proc sort; by ex rdate ; run; 

