libname rsch "c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\rsch\";
libname crsp "c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\crsp\";
libname temp "c:\sas data\temp" OUTREP=WINDOWS_32;
libname ind "c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\sas data\";
Options Mautosource Sasautos="c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\sas programs\sas macros\";
ods graphics off;






*******************************************************************
					Duration Portfolio and Value Spread 
*******************************************************************;

data msf_dur; set ind.msf_dur(where = (month(rdate) = 6 and keep_obs = 1)); dur = - dur; run; 
%portfolio(infile=msf_dur, sizevar = me, xvar = dur, keep_all = 1, k = 12, uscondsort=0, keepsmb=1); 
data ind.ltg_dur; set ltg_dur;run; data dur; set dur; dur = dur; rename smb = smb_dur ; run;
proc sql; create table ind.dur as select distinct a.*, b.* from dur a, rsch.msi b where a.date=b.date and a.ex=b.ex;


proc sql; create table price_dur as select distinct a.date, a.ex, log(sum(durw_l_lc*bm)) as bm_long_lc, log(sum(durw_l_sc*bm)) as bm_long_sc,
log(sum(durw_s_lc*bm)) as bm_short_lc, log(sum(durw_s_sc*bm)) as bm_short_sc from dur_w a , rsch.bm(where = (be > 0 and me > 0)) b
where a.vid=b.vid and a.rdate=b.rdate group by a.ex, a.date;
data ind.price_dur;set price_dur; format bm_long_sc bm_long_lc bm_short_sc bm_short_lc 9.4; run;

proc delete data = _all_;run;


%portfolio_divs(infile=ind.asf_dur(where = (ex="USA" and me > 0 and keep_obs = 1)), xvar = dur, k=180);
data ind.factor_divs_dur; set divs_dur;ind=compress(nyse_size||"__"||BMR);label ind = "nyse_bmr";run;

data dur; set ind.factor_divs_dur; I=intck('month', refresh_date, date); proc sort; by ind refresh_date I; run;

data dur; set dur(where = (I > 0)); retain P 100; by ind refresh_date; if first.refresh_date then P=100; P=P*(1+retx); run;
data dur ; set dur;
by ind refresh_date;
div = lag(P)*(ret-retx);
if first.refresh_date then div = 100*(ret-retx);
run;

data dur;  set dur; where year(refresh_date) le 2005; I=intck('month', refresh_date, date); year= 1;
if I>12 then year = 2; if I>24 then year = 3;  if I>36 then year = 4; if I>48 then year = 5;
if I>60 then year = 6; if I>72 then year = 7;  if I>84 then year = 8; if I>96 then year = 9;
if I>108 then year = 10; if I>120 then year = 11; if I>132 then year = 12; if I>144 then year = 13;
if I>156 then year = 14; if I>168 then year = 15; run;

proc sql;
create table test as select distinct
ind, year, mean(retx)*100*12 format 9.4 as retx,
mean(ret)*100*12 format 9.4 as ret, mean(P) as price
from dur group by ind, year; 


proc sql; create table sums as select distinct 
ind, refresh_date, year, sum(div) as div format 11.6
from dur group by ind, refresh_date, year;

create table means as select distinct year, ind, mean(div) as div format 11.6
from sums group by year, ind;

create table inf as select distinct a.date, log(1+b.inf1m) as inf 
from dur a, crsp.inf b where a.date=b.date;

create table inf as select distinct exp(12*mean(inf))-1 as inf from inf;

proc transpose data = means out = transpose prefix = Dur ; by year; id ind ; run;quit;

proc sql; create table ind.factor_divs_t as select distinct
a.*, b.inf 
from transpose a, inf b;


proc sql; create table ind.factor_divs as select distinct
a.*, b.inf 
from means a, inf b;

proc delete data = _all_; run;



%portfolio_earnings(infile=ind.asf_dur(where = (ex="USA" and me > 0)), xvar = dur, k=180);
data ind.factor_earn_dur; set earn_dur;ind=compress(nyse_size||"__"||BMR);label ind = "nyse_bmr";run;

data dur; set ind.factor_earn_dur; I=intck('month', refresh_date, date); proc sort; by ind refresh_date I; where year(refresh_date) ge 1951; run;


data dur; set dur; retain P 100; by ind refresh_date; if first.refresh_date then P=100; P=P*(1+retx); run;
data dur ; set dur(where = (I > 0));
by ind refresh_date;
earn = lag(P)*(ep);
if first.refresh_date then earn = ep;
run;

data dur;  set dur;  where year(refresh_date) le 2005; I=intck('month', refresh_date, date); year= 1;
if I>12 then year = 2; if I>24 then year = 3;  if I>36 then year = 4; if I>48 then year = 5;
if I>60 then year = 6; if I>72 then year = 7;  if I>84 then year = 8; if I>96 then year = 9;
if I>108 then year = 10; if I>120 then year = 11; if I>132 then year = 12; if I>144 then year = 13;
if I>156 then year = 14; if I>168 then year = 15; run;

proc sql;
create table test as select distinct
ind, year, mean(retx)*100*12 format 9.4 as retx,
mean(ret)*100*12 format 9.4 as ret, mean(P) as price
from dur group by ind, year; 


proc sql; create table sums as select distinct 
ind, refresh_date, year, mean(earn) as earn format 11.6
from dur group by ind, refresh_date, year;

create table means as select distinct year, ind, mean(earn) as earn format 11.6
from sums group by year, ind;

create table inf as select distinct a.date, log(1+b.inf1m) as inf 
from dur a, crsp.inf b where a.date=b.date;

create table inf as select distinct exp(12*mean(inf))-1 as inf from inf;

proc transpose data = means out = transpose prefix = Dur ; by year; id ind ; run;quit;

proc sql; create table ind.factor_earn_t as select distinct
a.*, b.inf 
from transpose a, inf b;

proc sql; create table ind.factor_earn as select distinct
a.*, b.inf 
from means a, inf b;

proc delete data = _all_; run;




*************************************************************
						Prepare P10
*************************************************************;

%p10(ind.msf_dur(where = (me > 0 and keep_obs=1)), dur);
data ind.p10_dur; set p10_dur ; where ex="USA"; run;

proc sql ; create table ind.p10_yields as select distinct a.ind, a.ex, a.rdate, a.date, log(sum(w*bm)) as bm format 11.6
from p10_w_dur a, rsch.acc(where = (ex="USA" and be > 0 and me > 0)) b where a.vid=b.vid and a.rdate=b.rdate
group by a.ex, a.ind, a.rdate;

%p10_exp(ind.msf_dur(where = (me > 0 and keep_obs=1)), dur);
data ind.p10_ltg_dur; set p10_ltg_dur; run;

proc delete data = _all_ ; run ;

%p10_divs(ind.asf_dur(where = (ex="USA" and month(rdate) = 6 and me > 0 and keep_obs=1)), dur, k=180);
data temp.p10_divs_dur; set p10_divs_dur;run;

data p10; set temp.p10_divs_dur; I=intck('month', refresh_date, date); proc sort; by ind refresh_date I; run;
data p10; set p10(where = (I > 0));
retain P 100;
by ind refresh_date;
if first.refresh_date then P=100;
P=P*(1+retx);
run;

data p10 ; set p10;
by ind refresh_date;
div = lag(P)*(ret-retx);
if first.refresh_date then div = 100*(ret-retx);
run;

data p10;  set p10; where 1963 le year(refresh_date) le 2005; I=intck('month', refresh_date, date); year= 1;
if I>12 then year = 2; if I>24 then year = 3;  if I>36 then year = 4; if I>48 then year = 5;
if I>60 then year = 6; if I>72 then year = 7;  if I>84 then year = 8; if I>96 then year = 9;
if I>108 then year = 10; if I>120 then year = 11; if I>132 then year = 12; if I>144 then year = 13;
if I>156 then year = 14; if I>168 then year = 15; run;

proc sql; create table sums as select distinct
ind, refresh_date, year, sum(div) as div format 11.6
from p10 group by ind, refresh_date, year;

create table means as select distinct year, ind, mean(div) as div format 11.6
from sums group by year, ind;

create table inf as select distinct a.date, log(1+b.inf1m) as inf 
from p10 a, crsp.inf b where a.date=b.date;

create table inf as select distinct exp(12*mean(inf))-1 as inf from inf;

proc transpose data = means out = transpose prefix = Dur ; by year; id ind ; run;quit;

proc sql; create table ind.p10_divs_t as select distinct
a.*, b.inf 
from transpose(drop = _NAME_ Dur11) a, inf b;

proc sql; create table ind.p10_divs as select distinct
a.*, b.inf 
from means a, inf b;

proc delete data = _all_; run;



%p10_earnings(ind.asf_dur(where = (ex="USA" and month(rdate)=6 and me > 0)), dur, k=180); ** Has to be rerun with the kkep_obs = 1 option if we want to use it ; 


data ind.p10_earnings_dur; set p10_earnings_dur; run;

data p10; set ind.p10_earnings_dur; I=intck('month', refresh_date, date); proc sort; by ind refresh_date I; run;
data p10; set p10(where = (I > 0));;
retain P 100;
by ind refresh_date;
if first.refresh_date then P=100;
P=P*(1+retx);
run;

data p10 ; set p10;
by ind refresh_date;
earn = lag(P)*ep/100;
if first.refresh_date then earn = ep;
run;


data p10;  set p10; where 1957 < year(refresh_date) le 2005; I=intck('month', refresh_date, date);
year= -4;
if I>-48 then year = -3; 
if I>-36 then year = -2; 
if I>-24 then year = -1; 
if I>-12 then year = 0; 
if I> 0 then year = 1; 
if I>12 then year = 2; if I>24 then year = 3;  if I>36 then year = 4; if I>48 then year = 5;
if I>60 then year = 6; if I>72 then year = 7;  if I>84 then year = 8; if I>96 then year = 9;
if I>108 then year = 10; if I>120 then year = 11; if I>132 then year = 12; if I>144 then year = 13;
if I>156 then year = 14; if I>168 then year = 15; run;


proc sql; create table sums as select distinct
ind, refresh_date, year, mean(earn) as earn format 11.6
from p10 group by ind, refresh_date, year;

create table means as select distinct year, ind, mean(earn) as earn format 11.6
from sums group by year, ind;

create table inf as select distinct a.date, log(1+b.inf1m) as inf 
from p10 a, crsp.inf b where a.date=b.date;

create table inf as select distinct exp(12*mean(inf))-1 as inf from inf;

proc transpose data = means out = transpose prefix = Dur ; by year; id ind ; run;quit;

proc transpose data = means out = transpose prefix = Dur ; by year; id ind ; run;quit;

proc sql; create table ind.p10_earn_t as select distinct
a.*, b.inf 
from transpose(drop = _NAME_ Dur11) a, inf b;

proc sql; create table ind.p10_earn as select distinct
a.*, b.inf 
from means a, inf b;

proc delete data = _all_; run;









**********************************************************************************************************

								Create factors dataset

**********************************************************************************************************;


** Create beta and paoyt factors;

%portfolio(infile=ind.raws(where = (month(rdate)=6)), k=12, xvar = beta, uscondsort = 0, sizevar=me);
%portfolio(infile=ind.raws(where = (month(rdate)=6)), k=12, xvar = pay,  uscondsort = 0, sizevar=me);


proc sql; create table ind.factors as select distinct
a.*, b.*, -c.beta as beta, d.pay 
from rsch.ff5 a, ind.dur b, beta c, pay d
where a.date=b.date=c.date=d.date and a.ex=b.ex=c.ex=d.ex; 


data temp_in; set ind.raws(where= (month(rdate)=6));
rmw = op;
hml = bm;
cma = - inv; 
run;


%portfolio(infile=temp_in, xvar=hml, sizevar=me, k=12, retfile=rsch.msf, uscondsort=0, keepsmb=1, keep_all=0);
%portfolio(infile=temp_in, xvar=rmw, sizevar=me, k=12, retfile=rsch.msf, uscondsort=0, keepsmb=0, keep_all=0);
%portfolio(infile=temp_in, xvar=cma, sizevar=me, k=12, retfile=rsch.msf, uscondsort=0, keepsmb=0, keep_all=0);


proc sql;
create table factors_ltg as select distinct a.*, b.*
from ind.ltg_dur a, ltg_hml b where a.ex=b.ex and a.date=b.date;

create table factors_ltg as select distinct a.*, b.* 
from factors_ltg a, ltg_rmw b where a.ex=b.ex and a.date=b.date;

create table factors_ltg as select distinct a.*, b.* 
from factors_ltg a, ltg_cma b where a.ex=b.ex and a.date=b.date;

create table factors_ltg as select distinct a.*, -b.beta as beta format 11.6
from factors_ltg a left join ltg_beta b on a.ex=b.ex and a.date=b.date;

create table ind.ltg_factors as select distinct a.*, b.PAY
from factors_ltg a left join ltg_pay b on a.ex=b.ex and a.date=b.date;


proc delete data = _all_; run;

data factors; set ind.factors; where ex = "USA"; mkt = mkt +rf; proc sort; by descending date;run;

data ind.factors_predict; set factors;  


s = lag(1+smb)*lag2(1+smb)*lag3(1+smb)*lag4(1+smb)*lag5(1+smb)*lag6(1+smb)
*lag7(1+smb)*lag8(1+smb)*lag9(1+smb)*lag10(1+smb)*lag11(1+smb)*lag12(1+smb)-1;
r = lag(1+rmw)*lag2(1+rmw)*lag3(1+rmw)*lag4(1+rmw)*lag5(1+rmw)*lag6(1+rmw)
*lag7(1+rmw)*lag8(1+rmw)*lag9(1+rmw)*lag10(1+rmw)*lag11(1+rmw)*lag12(1+rmw)-1;
c = lag(1+cma)*lag2(1+cma)*lag3(1+cma)*lag4(1+cma)*lag5(1+cma)*lag6(1+cma)
*lag7(1+cma)*lag8(1+cma)*lag9(1+cma)*lag10(1+cma)*lag11(1+cma)*lag12(1+cma)-1;
h = lag(1+hml)*lag2(1+hml)*lag3(1+hml)*lag4(1+hml)*lag5(1+hml)*lag6(1+hml)
*lag7(1+hml)*lag8(1+hml)*lag9(1+hml)*lag10(1+hml)*lag11(1+hml)*lag12(1+hml)-1;

*m = lag(1+mom)*lag2(1+mom)*lag3(1+mom)*lag4(1+mom)*lag5(1+mom)*lag6(1+mom)
*lag7(1+mom)*lag8(1+mom)*lag9(1+mom)*lag10(1+mom)*lag11(1+mom)*lag12(1+mom)-1;
p = lag(1+pay)*lag2(1+pay)*lag3(1+pay)*lag4(1+pay)*lag5(1+pay)*lag6(1+pay)
*lag7(1+pay)*lag8(1+pay)*lag9(1+pay)*lag10(1+pay)*lag11(1+pay)*lag12(1+pay)-1;
b = lag(1+beta)*lag2(1+beta)*lag3(1+beta)*lag4(1+beta)*lag5(1+beta)*lag6(1+beta)
*lag7(1+beta)*lag8(1+beta)*lag9(1+beta)*lag10(1+beta)*lag11(1+beta)*lag12(1+beta)-1;
d = lag(1+dur)*lag2(1+dur)*lag3(1+dur)*lag4(1+dur)*lag5(1+dur)*lag6(1+dur)
*lag7(1+dur)*lag8(1+dur)*lag9(1+dur)*lag10(1+dur)*lag11(1+dur)*lag12(1+dur)-1;
d_ucon = lag(1+dur_ucon)*lag2(1+dur_ucon)*lag3(1+dur_ucon)*lag4(1+dur_ucon)*lag5(1+dur_ucon)*lag6(1+dur_ucon)
*lag7(1+dur_ucon)*lag8(1+dur_ucon)*lag9(1+dur_ucon)*lag10(1+dur_ucon)*lag11(1+dur_ucon)*lag12(1+dur_ucon)-1;
m = lag(1+mkt)*lag2(1+mkt)*lag3(1+mkt)*lag4(1+mkt)*lag5(1+mkt)*lag6(1+mkt)
*lag7(1+mkt)*lag8(1+mkt)*lag9(1+mkt)*lag10(1+mkt)*lag11(1+mkt)*lag12(1+mkt)-1;
m2=(1+m)*lag12(1+m)-1;
m3=(1+m)*lag12(1+m)*lag24(1+m)-1;
m4=(1+m)*lag12(1+m)*lag24(1+m)*lag36(1+m)-1;
m5=(1+m)*lag12(1+m)*lag24(1+m)*lag36(1+m)*lag48(1+m)-1;
format s b m r c h d d_ucon m m2 m4 m4 m5 11.6;
run;



proc delete data = _all_; run;







