libname rsch "c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\rsch\";
libname crsp "c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\crsp\";
libname temp "c:\sas data\temp" OUTREP=WINDOWS_32;
libname ind "c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\sas data\";
Options Mautosource Sasautos="c:\users\ngormsen\dropbox\durationbasedap\final version\data and programs\submitted code\sas\sas programs\sas macros\";
ods graphics off;




**************************************************************************

				Alternative duration characteristics

**************************************************************************;


proc reg data = ind.msf_exp_percent noprint outest = b1 rsquare; by ex; model medest = op bm inv beta pay ; weight numest; run; quit;

proc sql; create table temp3 as select distinct
a.*, b.op as bop, b.inv as binv, b.beta as bbeta, b.bm as bbm, b.pay as bpay
from ind.raws a , b1 b where a.ex=b.ex
order by ex, rdate;

data temp3; set temp3; proc sort; by ex rdate; run;

proc rank data = temp3 out = temp4 percent; by ex rdate; var op inv bm mep beta pay ; run; 

data temp4; set temp4;rmw = op ; cma = - inv; 
inv2 = inv;    if inv = .  then inv2   = 50;
op2 = op;      if op = .   then op2    = 50;
bm2 = bm;      if bm = .   then bm2    = 50;
iv2 = iv;      if iv = .   then iv2    = 50;
beta2 = beta;  if beta = . then beta2  = 50;
pay2 = pay;    if pay = .  then pay2   = 50;

o   = op2*bop;
in  = inv2*binv;
b   = bm2*bbm;
bet = beta2 * bbeta;
p   = pay2 * bpay;
dur = sum(o, in, p, bet); 


***** Alternative specification based on univariate correlations ****** ;

*o   = op2	 * 0.09;
*in  = inv2	 * 0.35;
*bet = beta2  * 0.37;
*p   = pay2   * 0.35;
*dur = sum(o, in, p, bet); 

*** Alternative based on simple averages ***** ;

op_t = -1*op; pay_t = -1*pay; bm_t = -1*bm;

dur1 = mean(op_t, pay_t, beta2, inv2, bm_t);
dur2 = mean(op_t, pay_t, beta2, inv2);

keep_obs = 1;
if beta = . and inv = . and op = . and pay = . then keep_obs = 0; 

run;

data temp.msf_dur; set temp4;format dur 9.4; keep dur1 dur2 ex me me_company exchcd cma rmw op inv bm rdate vid dur beta iv bop binv bbm biv bbeta beta2 iv2 bm2 op2 inv2 bop binv bbm biv bbeta ltg_hat m bme mep mep2 medest p pay bpay keep_obs; run;

data msf_dur; set temp.msf_dur(where = (month(rdate) = 6 and keep_obs = 1)); dur1 = - dur1; dur2 = -dur2; run; 

%portfolio(infile=msf_dur, sizevar = me, xvar = dur1, keep_all = 1, k = 12, uscondsort=0, keepsmb=1); 
proc sql; create table temp.factors1 as select distinct
a.dur1 as dur, a.smb as dur_smb, b.*
from dur1 a , ind.factors b where a.ex=b.ex and a.date=b.date;


%portfolio(infile=msf_dur, sizevar = me, xvar = dur2, keep_all = 1, k = 12, uscondsort=0, keepsmb=1); 
proc sql; create table temp.factors2 as select distinct
a.dur2 as dur, a.smb as dur_smb, b.*
from dur2 a , ind.factors b where a.ex=b.ex and a.date=b.date;



%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=dur, control = 0 , rf=0, out=dur_c, infile2=ind.ltg_dur(where = (ex="USA")));
%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=dur_l_lc, control = 0 , rf=1, out=dur_l_lc_c, infile2=ind.ltg_dur(where = (ex="USA")));
%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=dur_l_sc, control = 0 , rf=1, out=dur_l_sc_c, infile2=ind.ltg_dur(where = (ex="USA")));
%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=dur_s_lc, control = 0 , rf=1, out=dur_s_lc_c, infile2=ind.ltg_dur(where = (ex="USA")));
%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=dur_s_sc, control = 0 , rf=1, out=dur_s_sc_c, infile2=ind.ltg_dur(where = (ex="USA")));
%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=smb, control = 0  , out=smb_c, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=smb, control = 1  , out=smb_d, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=hml, control = 0  , out=hml_c, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=hml, control = 1  , out=hml_d, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=rmw, control = 0  , out=rmw_c, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=rmw, control = 1  , out=rmw_d, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=cma, control = 0  , out=cma_c, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=cma, control = 1  , out=cma_d, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=beta, control = 0 , out=beta_c, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=beta, control = 1 , out=beta_d, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=iv, control = 0   , out=iv_c, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=iv, control = 1   , out=iv_d, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=pay, control = 0  , out=pay_c, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors1(where = (ex="USA" and date > MDY(7,1,1963))), xvar=pay, control = 1  , out=pay_d, infile2=ind.ltg_factors(where = (ex="USA")));

data Table3A_App; merge dur_c dur_l_lc_c dur_l_sc_c dur_s_lc_c dur_s_sc_c;run;

data Table4A_App; merge dur_c smb_c hml_c rmw_c cma_c beta_c  pay_c;run;
data Table4B_App; merge dur_c smb_d hml_d rmw_d cma_d beta_d  pay_d;run;
proc delete data = div iv_c ic_d pay_c pay_d dur_l_lc_c dur_l_sc_c dur_s_lc_c dur_s_sc_c dur_c smb_c hml_c rmw_c cma_c beta_c mom_c dur_c smb_d hml_d rmw_d cma_d beta_d mom_d iv_d;run;


%export_results(Table3A_App);
%export_results(Table4A_App);
%export_results(Table4B_App);


%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=dur, control = 0 , rf=0, out=dur_c, infile2=ind.ltg_dur(where = (ex="WOR")));
%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=dur_l_lc, control = 0 , rf=1, out=dur_l_lc_c,  infile2=ind.ltg_dur(where = (ex="WOR")));
%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=dur_l_sc, control = 0 , rf=1, out=dur_l_sc_c,  infile2=ind.ltg_dur(where = (ex="WOR")));
%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=dur_s_lc, control = 0 , rf=1, out=dur_s_lc_c,  infile2=ind.ltg_dur(where = (ex="WOR")));
%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=dur_s_sc, control = 0 , rf=1, out=dur_s_sc_c, infile2=ind.ltg_dur(where = (ex="WOR")));
%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=smb, control = 0 , out=smb_c, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=smb, control = 1 , out=smb_d, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=hml, control = 0 , out=hml_c, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=hml, control = 1 , out=hml_d, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=rmw, control = 0 , out=rmw_c, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=rmw, control = 1 , out=rmw_d, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=cma, control = 0 , out=cma_c, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=cma, control = 1 , out=cma_d, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=beta, control = 0 , out=beta_c, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=beta, control = 1 , out=beta_d, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=iv, control = 0 , out=iv_c, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=iv, control = 1 , out=iv_d, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=pay, control = 0 , out=pay_c, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors1(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=pay, control = 1 , out=pay_d, infile2=ind.ltg_factors(where = (ex="WOR")));

data Table3B_App; merge dur_c dur_l_lc_c dur_l_sc_c dur_s_lc_c dur_s_sc_c;run;

data Table5A_App; merge dur_c smb_c hml_c rmw_c cma_c beta_c  pay_c;run;
data Table5B_App; merge dur_c smb_d hml_d rmw_d cma_d beta_d  pay_d;run;

%export_results(Table3B_App);
%export_results(Table5A_App);
%export_results(Table5B_App);

proc delete data =iv_c ic_d pay_c pay_d  dur_l_lc_c dur_l_sc_c dur_s_lc_c dur_s_sc_c dur_c smb_c hml_c rmw_c cma_c beta_c mom_c dur_c smb_d hml_d rmw_d cma_d beta_d mom_d iv_d;run;
proc delete data = _all_ ; run ;






%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=dur, control = 0 , rf=0, out=dur_c, infile2=ind.ltg_dur(where = (ex="USA")));
%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=dur_l_lc, control = 0 , rf=1, out=dur_l_lc_c, infile2=ind.ltg_dur(where = (ex="USA")));
%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=dur_l_sc, control = 0 , rf=1, out=dur_l_sc_c, infile2=ind.ltg_dur(where = (ex="USA")));
%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=dur_s_lc, control = 0 , rf=1, out=dur_s_lc_c, infile2=ind.ltg_dur(where = (ex="USA")));
%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=dur_s_sc, control = 0 , rf=1, out=dur_s_sc_c, infile2=ind.ltg_dur(where = (ex="USA")));
%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=smb, control = 0  , out=smb_c, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=smb, control = 1  , out=smb_d, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=hml, control = 0  , out=hml_c, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=hml, control = 1  , out=hml_d, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=rmw, control = 0  , out=rmw_c, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=rmw, control = 1  , out=rmw_d, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=cma, control = 0  , out=cma_c, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=cma, control = 1  , out=cma_d, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=beta, control = 0 , out=beta_c, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=beta, control = 1 , out=beta_d, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=iv, control = 0   , out=iv_c, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=iv, control = 1   , out=iv_d, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=pay, control = 0  , out=pay_c, infile2=ind.ltg_factors(where = (ex="USA")));
%regression(infile = temp.factors2(where = (ex="USA" and date > MDY(7,1,1963))), xvar=pay, control = 1  , out=pay_d, infile2=ind.ltg_factors(where = (ex="USA")));

data Table3A_App2; merge dur_c dur_l_lc_c dur_l_sc_c dur_s_lc_c dur_s_sc_c;run;

data Table4A_App2; merge dur_c smb_c hml_c rmw_c cma_c beta_c  pay_c;run;
data Table4B_App2; merge dur_c smb_d hml_d rmw_d cma_d beta_d  pay_d;run;
proc delete data = div iv_c ic_d pay_c pay_d dur_l_lc_c dur_l_sc_c dur_s_lc_c dur_s_sc_c dur_c smb_c hml_c rmw_c cma_c beta_c mom_c dur_c smb_d hml_d rmw_d cma_d beta_d mom_d iv_d;run;


%export_results(Table3A_App2);
%export_results(Table4A_App2);
%export_results(Table4B_App2);


%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=dur, control = 0 , rf=0, out=dur_c, infile2=ind.ltg_dur(where = (ex="WOR")));
%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=dur_l_lc, control = 0 , rf=1, out=dur_l_lc_c,  infile2=ind.ltg_dur(where = (ex="WOR")));
%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=dur_l_sc, control = 0 , rf=1, out=dur_l_sc_c,  infile2=ind.ltg_dur(where = (ex="WOR")));
%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=dur_s_lc, control = 0 , rf=1, out=dur_s_lc_c,  infile2=ind.ltg_dur(where = (ex="WOR")));
%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=dur_s_sc, control = 0 , rf=1, out=dur_s_sc_c, infile2=ind.ltg_dur(where = (ex="WOR")));
%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=smb, control = 0 , out=smb_c, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=smb, control = 1 , out=smb_d, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=hml, control = 0 , out=hml_c, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=hml, control = 1 , out=hml_d, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=rmw, control = 0 , out=rmw_c, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=rmw, control = 1 , out=rmw_d, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=cma, control = 0 , out=cma_c, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=cma, control = 1 , out=cma_d, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=beta, control = 0 , out=beta_c, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=beta, control = 1 , out=beta_d, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=iv, control = 0 , out=iv_c, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=iv, control = 1 , out=iv_d, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=pay, control = 0 , out=pay_c, infile2=ind.ltg_factors(where = (ex="WOR")));
%regression(infile = temp.factors2(where = (ex="WOR" and date > MDY(7,1,1990))), xvar=pay, control = 1 , out=pay_d, infile2=ind.ltg_factors(where = (ex="WOR")));

data Table3B_App2; merge dur_c dur_l_lc_c dur_l_sc_c dur_s_lc_c dur_s_sc_c;run;

data Table5A_App2; merge dur_c smb_c hml_c rmw_c cma_c beta_c  pay_c;run;
data Table5B_App2; merge dur_c smb_d hml_d rmw_d cma_d beta_d  pay_d;run;

%export_results(Table3B_App2);
%export_results(Table5A_App2);
%export_results(Table5B_App2);

proc delete data =iv_c ic_d pay_c pay_d  dur_l_lc_c dur_l_sc_c dur_s_lc_c dur_s_sc_c dur_c smb_c hml_c rmw_c cma_c beta_c mom_c dur_c smb_d hml_d rmw_d cma_d beta_d mom_d iv_d;run;
proc delete data = _all_ ; run ;








********************************************************************************************

										Table 7: yield curve

*******************************************************************************************;

proc sql ; create table predict as select distinct a.*, b.* 
from ind.price_dur a left join ind.factors_predict b on a.ex=b.ex  and a.date=b.date ; 

data predict ; set predict ; level_lc = mean(bm_long_lc, bm_short_lc); level_sc = mean(bm_long_sc, bm_short_sc);
slope_lc = -1*(bm_long_lc- bm_short_lc); slope_sc = -1* (bm_long_sc- bm_short_sc); run;

data predict; set predict; bm_short = mean(level_lc, level_sc); bm_long = mean(slope_lc, slope_sc); 
level = mean(level_lc, level_sc); slope = mean(slope_lc, slope_sc);  run;

proc sql; create table yields as select distinct
a.ex, a.date, a.level, a.slope, b.slope as slope_bonds format 9.6
from predict(where = (ex="USA")) a left join ind.treasury_slope b on a.date=b.date;

data yields(drop = slope_bonds2); set yields; slope_bonds2= slope_bonds; if slope_bonds2 = 0 then slope_bonds = . ; run;




%regression_slope(infile = yields, xvar=slope, out=slope_1);
%regression_slope(infile = yields(where = ( ex = "USA" and year(date) le 1974)), xvar=slope, out=slope_2);
%regression_slope(infile = yields(where = ( ex = "USA" and 1974 < year(date) le 1995)), xvar=slope, out=slope_3);
%regression_slope(infile = yields(where = ( ex = "USA" and 1995 < year(date))), xvar=slope, out=slope_4);

data Table7_new; merge slope_1 slope_2 slope_3 slope_4; run;

%export_results(Table7_new);
data yields; set yields; where ex = "USA" ; run;
%export_results(yields);


proc sql; create table predict as select distinct
a.*, b.slope as slope_bonds format 9.6
from predict(where = (ex="USA")) a left join ind.treasury_slope b on a.date=b.date;

%regression_predict(infile = predict(where = (ex="USA" and date > MDY(7,1,1963))), xvar=d, out=predict_d);
%regression_predict(infile = predict(where = (ex="USA" and date > MDY(7,1,1963))), xvar=s, out=predict_s);
%regression_predict(infile = predict(where = (ex="USA" and date > MDY(7,1,1963))), xvar=h, out=predict_h);
%regression_predict(infile = predict(where = (ex="USA" and date > MDY(7,1,1963))), xvar=r, out=predict_r);
%regression_predict(infile = predict(where = (ex="USA" and date > MDY(7,1,1963))), xvar=c, out=predict_c);
%regression_predict(infile = predict(where = (ex="USA" and date > MDY(7,1,1963))), xvar=b, out=predict_b);
%regression_predict(infile = predict(where = (ex="USA" and date > MDY(7,1,1963))), xvar=i, out=predict_i);
%regression_predict(infile = predict(where = (ex="USA" and date > MDY(7,1,1963))), xvar=p, out=predict_p);
%regression_predict(infile = predict(where = (ex="USA" and date > MDY(7,1,1963))), xvar=m, out=predict_m);
%regression_predict(infile = predict(where = (ex="USA" and date > MDY(7,1,1963))), xvar=m2, out=predict_m2, lags = 24);
%regression_predict(infile = predict(where = (ex="USA" and date > MDY(7,1,1963))), xvar=m3, out=predict_m3, lags = 36);
%regression_predict(infile = predict(where = (ex="USA" and date > MDY(7,1,1963))), xvar=m4, out=predict_m4, lags = 48);
%regression_predict(infile = predict(where = (ex="USA" and date > MDY(7,1,1963))), xvar=m5, out=predict_m5, lags = 60);

data Table7a; merge predict_d predict_s predict_h predict_r predict_c predict_b predict_i predict_p; run;
data Table7b; merge predict_m predict_m2 predict_m3 predict_m4 predict_m5;	run;

%export_results(Table7a);
%export_results(Table7b);

proc delete data = predict_d predict_s predict_h predict_r predict_c predict_b predict_m predict_m2 predict_m3 predict_m4 predict_m5; run ;








********************************************************************************************

										Factor Zoo - Weber Data 

*******************************************************************************************;




data single; set ind.weber(where = ( f1=626394)); drop 
rdate date ret loc_ret me prc shares adj indus exchcd fx
me_company usfirm F1 yearmonth permno yy mm  dateff 
mktrf smb hml rf umd exret;
run; ** This is a single firm to get the names of the variables;


proc transpose data = single out = list;run;
data list; set list; drop col1; rename _NAME_ = name;run;

proc sql NOPRINT;
  select distinct name into : name_list separated by " " from list;
quit;


proc sql;
create table factors as select distinct
a.*, b.*
from ind.factors_weber a, ind.factors b where a.ex=b.ex and a.date=b.date;


%MACRO alphas;

proc delete data = capm_alpha dur_alpha; run ;

%local i next_name;
%do i=1 %to %sysfunc(countw(&name_list));
   %let next_name = %scan(&name_list, &i);

	%put "Computing factor number &i which is &next_name";

	proc reg data = factors noprint TABLEOUT outest = b1;
	model &next_name = mkt ; run; quit;

	proc reg data = factors noprint TABLEOUT outest = b2;
	model &next_name = mkt dur ; run; quit;
	
	proc sql; 
	create table b1b as select distinct
	a._DEPVAR_ as factor format $25., a.intercept as alpha, b.intercept as tstat, c.intercept as pvalue
	from b1(where = (_TYPE_ = "PARMS")) a, b1(where = (_TYPE_="T")) b, b1(where = (_TYPE_="PVALUE")) c;

	create table b2b as select distinct
	a._DEPVAR_ as factor format $25., a.intercept as dur_alpha, b.intercept as dur_tstat, c.intercept as dur_pvalue
	from b2(where = (_TYPE_ = "PARMS")) a, b2(where = (_TYPE_="T")) b, b2(where = (_TYPE_="PVALUE")) c;

	proc append data = b1b base = capm_alpha FORCE ;run;
	proc append data = b2b base = dur_alpha FORCE ;run;

	proc delete data = b1 b2 b1b b2b; run ;
%end;

data capm_alpha; set capm_alpha; type=1; run; data dur_alpha; set dur_alpha; type=1; run;
data capm_alpha; set capm_alpha; by type; if first.type the id = 0; id+1; run;
data dur_alpha; set dur_alpha; by type; if first.type then id = 0; id+1; run;

%MEND;

%alphas;

proc reg data = factors ; model beme=;run;
proc sql; create table output as select distinct 
a.*, b.*
from capm_alpha(where = (pvalue < 0.05 and factor ne "lme" and factor ne "total_vol" and factor ne "cum_retur" and factor ne "investmen" and factor ne "beme" and factor ne "prof" and factor ne "beta")) a, dur_alpha b 
where a.id=b.id order by dur_pvalue;

data output; set output; p = dur_pvalue;
t=abs(dur_tstat);
*if sign(tstat) = -1*sign(dur_tstat) then t=1*t; 
proc sort; by p ;
run;

data output; set output;
by type; if first.type then nr = 0; nr + 1; run;

proc sql; create table output as select distinct 
a.*, 0.05*nr/sum(type) as bh_cutoff from output a;

proc sort data = output ; by p; run;

data Table6_new; set output; sig = 0; if p < bh_cutoff then sig = 1; run;


%export_results(Table6_new);
