


%macro Table1(infile=ind.p10_dur(where = (ex="USA")), infile2 = ind.p10_divs);



proc reg data = &infile outest = out0 TABLEOUT noprint; 
by ex ind ; 
model xret =  ; run ; 

proc reg data = &infile outest = out4 TABLEOUT noprint ADJRSQ; 
by ex ind ;  where ex not in ('INT'); 
model xret = mkt  ; 
OUTPUT OUT = e residual = e;
run ; 


data xr    ; set out0 ; where _TYPE_ = 'PARMS';  keep ex ind xret   ; xret   = intercept*100 ; run ; 
data a4f   ; set out4 ; where _TYPE_ = 'PARMS';  keep ex ind alpha4 ; alpha4 = intercept*100 ; run ; 

data txr    ; set out0 ; where _TYPE_ = 'T';  keep ex ind txret   ; txret   = intercept ; run ; 
data ta4f   ; set out4 ; where _TYPE_ = 'T';  keep ex ind talpha4 ; talpha4 = intercept ; run ; 


data load ; set out4 ; where _TYPE_ = 'PARMS';  keep ex ind mkt  ; run ; 
data tload ; set out4 ; where _TYPE_ = 'T';  keep ex ind tmkt  ;
tmkt = mkt ; 
run ; 

data load ; merge xr txr a4f ta4f load tload ; run ;


proc sql;
create table div as select distinct
"USA" as ex, a.ind, a.div as div_1, b.div as div_2, a.inf
from &infile2(where = (year=1)) a, &infile2(where = (year=15)) b
where a.ind=b.ind;

create table div2 as select distinct a.ex, a.ind, mean(ltg) as ltg2 format 9.6 from ind.p10_ltg_dur a group by ex, ind;
create table div2(drop = ltg2) as select distinct a.*, (1+a.ltg2)/((1+mean(inf1m))**12)-1 as ltg from div2 a, crsp.inf(where = (year(date) ge 1982)) b; 
data div(keep = ex ind growth); set div; growth = ((div_2/div_1)**(1/14))/(1+inf)-1; if ind = 11 then growth = . ; format growth 9.6; run;



proc sql;
create table earn as select distinct
"USA" as ex, a.ind, a.earn as earn_1, b.earn as earn_2, a.inf
from ind.p10_earn(where = (year=1)) a, ind.p10_earn(where = (year=15)) b
where a.ind=b.ind;

data earn(keep = ex ind growth_e); set earn; growth_e = ((earn_2/earn_1)**(1/14))/(1+inf)-1; if ind = 11 then growth = . ; format growth 9.6; run;


proc sql ; 
create table ee as select distinct
ex , ind , sqrt(12)*mean(xret)/std(xret) as SR , std(e)*sqrt(12) as rvol
from e group by ex , ind; 

create table n as select distinct
ex , ind ,sum(xret^=.) as num
from e group by ex , ind; 



data u ; 
merge load ee; 
by ex ind ; 
IR = 12*(alpha4/100)/rvol ; 
drop rvol ; run ; 


data r2 ; 
set out4 ; 
where _ADJRSQ_ ^=. ; 
keep ex R2 ind  ; 
R2 = _ADJRSQ_ ; 
run;


data xret ; 
merge  u  r2  n div earn div2; 
by ex ind ; 
run ; 


proc transpose data = xret  out = Table1(where = (_NAME_ ^= 'ind') drop = _LABEL_) ; where ex = 'USA'; run ; 

* house cleaning ; 
*proc delete data = xr txr a4f ta4f u out4 load out0  tload e ee n R2 P10 xret div ; run ; 

%mend;
