



%macro regression(infile=&infile, xvar = &xvar , control = 0, out = , rf=0, infile2=&infile2);


data p10;
set &infile;
xret = &xvar;
ind=1;
run;

%if &control=0 %then %do;

data p10;
set p10;
smb_dur = 1;
dur = 1 ;
run;

%end;

%if &rf=1 %then %do;

data p10;
set p10;
xret = xret - rf ;
run;

%end;


proc reg data = P10 outest = out0 TABLEOUT noprint; 
by ex ind ; 
model xret =  ; run ; 


proc reg data = P10 outest = out4 TABLEOUT noprint ADJRSQ; 
by ex ind ;   
model xret = mkt smb_dur dur ; 
OUTPUT OUT = e residual = e;
run ; 


data xr    ; set out0 ; where _TYPE_ = 'PARMS';  keep ex ind xret   ; xret   = intercept*100 ; run ; 
data a4f   ; set out4 ; where _TYPE_ = 'PARMS';  keep ex ind alpha ; alpha = intercept*100 ; run ; 

data txr    ; set out0 ; where _TYPE_ = 'T';  keep ex ind txret   ; txret   = intercept ; run ; 
data ta4f   ; set out4 ; where _TYPE_ = 'T';  keep ex ind talpha ; talpha = intercept ; run ; 


data load ; set out4 ; where _TYPE_ = 'PARMS';  keep ex ind mkt smb_dur dur; run ; 
data tload ; set out4 ; where _TYPE_ = 'T';  keep ex ind tmkt tsmb_dur tdur ;
tmkt = mkt ; 
tdur = dur ; 
tsmb_dur = smb_dur; 
run ; 

data load ; merge xr txr  a4f ta4f load tload ; run ;

proc sql ; 
create table load as select distinct
ex , ind , xret , txret , alpha , talpha , mkt , tmkt , smb_dur, tsmb_dur, dur, tdur
from load 
order by ex , ind ;

create table ltg2 as select distinct
ex, 1 as ind, mean(&xvar) as ltg2 from &infile2 group by ex ;

create table ltg as select distinct
ex, ind, (1+ltg2)/((1+mean(b.inf1m))**12)-1 as ltg from ltg2 a, crsp.inf(where = (year(date) ge 1982)) b;

create table ee as select distinct
ex , ind , sqrt(12)*mean(xret)/std(xret) as SR , std(e)*sqrt(12) as rvol
from e group by ex , ind; 


create table n as select distinct
ex , ind ,sum(xret^=.) as num
from e group by ex , ind; 

data u ; 
merge load ee; 
by ex ind ; 
IR = 12*(alpha/100)/rvol ; 
run ; 


data r2 ; 
set out4 ; 
where _ADJRSQ_ ^=. ; 
keep ex R2 ind  ; 
R2 = _ADJRSQ_ ; 
run;


data out_temp ; 
merge  u  r2  n ltg; 
by ex ind ; 
drop rvol ;
run ; 

proc transpose data = out_temp  out = out_temp2(where = (_NAME_ ^= 'ind') drop = _LABEL_) ;  run ; 

data &out;
set out_temp2;
rename COL1=&xvar;run;

* house cleaning ; 
proc delete data = ltg xr txr a4f ta4f u out4 load out0 a1f ta1f tload e ee n R2 P10 xret out_temp out_temp2; run ; 

%mend;
