
clear all
cd "~/Dropbox/DurationBasedAP/Final version/Data and programs/input/Stata/Data/LTG"


use msf_exp_percent, clear
destring vid, generate(id) ignore("USA" "W" "C" "__" )
gen y_m = ym(year(rdate),month(rdate))
format y_m %tm

duplicates tag id y_m, gen(isdup)
egen id2 = concat(id exchcd), format(%10.0g)
gen id3 = real(id2)
replace id = id3 if isdup

tsset id y_m


/* generate low_inv = -1*inv
generate low_beta = -1*beta
generate low_iv = -1*iv */

generate i=1

generate size2 = log(me)



reghdfe medest bm op low_inv low_beta  pay if ex == "USA" [aw = numest], absorb(y_m) cluster(id y_m) 
outreg2 using temp/Table1C, tstat noaster replace ctitle(LTG US) addtext(FE, Date, Cluster, Firm/Date, Weight, Analysts, Sample, Full) dta 

reghdfe medest bm op low_inv low_beta  pay if ex == "USA" [aw = me], absorb(y_m) cluster(id y_m) 
outreg2 using temp/Table1C, tstat noaster append ctitle(LTG US) addtext(FE, Date, Cluster, Firm/Date, Weight, Market Cap, Sample, Full) dta

reghdfe medest bm op low_inv low_beta  pay if ex == "USA", absorb(y_m) cluster(id y_m) 
outreg2 using temp/Table1C, tstat noaster append ctitle(LTG US) addtext(FE, Date, Cluster, Firm/Date, Weight, None, Sample, Full) dta

reghdfe medest bm op low_inv low_beta  pay if ex == "USA" [aw = numest], absorb(id y_m) cluster(id y_m) 
outreg2 using temp/Table1C, tstat noaster append ctitle(LTG US) addtext(FE, Firm/Date, Cluster, Firm/Date, Weight, Analysts, Sample, Full) dta

reghdfe medest bm op low_inv low_beta  pay if ex == "USA" && year(date) <= 2000 [aw = numest], absorb(id y_m) cluster(id y_m) 
outreg2 using temp/Table1C, tstat noaster append ctitle(LTG US) addtext(FE, Firm/Date, Cluster, Firm/Date, Weight, Analysts, Sample, Early) dta

reghdfe medest bm op low_inv low_beta  pay if ex == "USA" && year(date) > 2000 [aw = numest], absorb(id y_m) cluster(id y_m) 
outreg2 using temp/Table1C, tstat noaster append ctitle(LTG US) addtext(FE, Firm/Date, Cluster, Firm/Date, Weight, Analysts, Sample, Late) dta


reghdfe medest bm op low_inv low_beta  pay if ex != "USA" [aw = numest], absorb(y_m) cluster(id y_m) 
outreg2 using temp/Table1D, tstat noaster replace ctitle(LTG INT) addtext(FE, Date, Cluster, Firm/Date, Weight, Analysts, Sample, Full) dta

reghdfe medest bm op low_inv low_beta  pay if ex != "USA" [aw = me], absorb(y_m) cluster(id y_m) 
outreg2 using temp/Table1D, tstat noaster append ctitle(LTG INT) addtext(FE, Date, Cluster, Firm/Date, Weight, Market Cap, Sample, Full) dta

reghdfe medest bm op low_inv low_beta  pay if ex != "USA", absorb(y_m) cluster(id y_m) 
outreg2 using temp/Table1D, tstat noaster append ctitle(LTG INT) addtext(FE, Date, Cluster, Firm/Date, Weight, None, Sample, Full) dta

reghdfe medest bm op low_inv low_beta  pay if ex != "USA", absorb(id y_m) cluster(id y_m) 
outreg2 using temp/Table1D, tstat noaster append ctitle(LTG INT) addtext(FE, Firm/Date, Cluster, Firm/Date, Weight, Analysts, Sample, Full) dta

reghdfe medest bm op low_inv low_beta  pay if ex != "USA" && year(date) <= 2005 [aw = numest], absorb(id y_m) cluster(id y_m) 
outreg2 using temp/Table1D, tstat noaster append ctitle(LTG INT) addtext(FE, Firm/Date, Cluster, Firm/Date, Weight, Analysts, Sample, Early) dta

reghdfe medest bm op low_inv low_beta  pay if ex != "USA" && year(date) > 2005 [aw = numest], absorb(id y_m) cluster(id y_m) 
outreg2 using temp/Table1D, tstat noaster append ctitle(LTG INT) addtext(FE, Firm/Date, Cluster, Firm/Date, Weight, Analysts, Sample, Late) dta




use Temp/Table1C_dta, clear
export excel using "../../Tables/Table1_C" , sheet("sheet1") replace

use Temp/Table1D_dta, clear
export excel using "../../Tables/Table1_D" , sheet("sheet1") replace




reghdfe medest bm  				if ex == "USA" [aw = numest], absorb(y_m) cluster(id y_m) 
reghdfe medest op 				if ex == "USA" [aw = numest], absorb(y_m) cluster(id y_m) 
reghdfe medest low_inv 			if ex == "USA" [aw = numest], absorb(y_m) cluster(id y_m) 
reghdfe medest low_beta 		if ex == "USA" [aw = numest], absorb(y_m) cluster(id y_m) 
reghdfe medest pay 				if ex == "USA" [aw = numest], absorb(y_m) cluster(id y_m) 


reghdfe medest bm op low_inv low_beta  pay if ex == "USA" & mep > 50 [aw = numest], absorb(y_m) cluster(id y_m) 


reghdfe medest  op low_inv low_beta  pay if ex == "USA" & mep > 50 [aw = numest], absorb(y_m) cluster(id y_m) 
reghdfe medest  op low_inv low_beta  pay if ex == "USA" & mep < 50 [aw = numest], absorb(y_m) cluster(id y_m) 
